/* first.cc
 *
 * This file is used in order to test the implemented functions and
 * shows the principle behaviour of the library
 */


#include <stdio.h>
#include <unistd.h>
#include <iostream.h>
#include "first.h"
#include "connection.h"
#include "kernel.h"


#define COUT_TIME cout << simtime << "->"
#define COUT_OBJ_INFO 						\
	cout << "obj_info: ";					\
	if( obj.distance != -1 ) { 				\
		cout << obj.distance << " : " << obj.direction;	\
		if( obj.dist_change != -1 ) {			\
			cout << " : " << obj.dist_change;	\
			if( obj.dir_change != -1 )		\
				cout << " : " << obj.dir_change;\
		}						\
	} else	cout << obj.direction;				\
	cout << "\n";


// choose, what to check:
#if 0
#define CHECK_HEAR_REFEREE
#define CHECK_HEAR_DIRECTION
#define CHECK_FLAGS_PENALTY
#define CHECK_SEE_FLAG
#define CHECK_SEE_FLAG_OBJINFO
#define CHECK_SEE_FLAG_CENTER
#define CHECK_SEE_FLAG_PENALTY
#define CHECK_SEE_FLAG_GOAL
#define CHECK_SEE_FLAG_OUTSIDE_X_Y
#define CHECK_SEE_GOAL_XY
#define CHECK_SEE_GOAL
#define CHECK_SEE_GOAL_SIDE
#define CHECK_SEE_LINE
#define CHECK_SEE_LINE_XY
#define CHECK_SEE_BALL
#define CHECK_SEE_PLAYNR_SIDE
#define CHECK_SEE_PLAYER_NAME
#define CHECK_SEE_PLAYER
#define CHECK_SEE_PLAYNR_SIDE_AND_FACE
#define CHECK_SEE_PLAYER_NAME_AND_FACE
#define CHECK_SEE_PLAYER_AND_FACE
#endif

struct position_t init_positions[ 11 ] = { 	{ -50,   0 },
						{ -28,   0 },
						{ -32,  16 },
						{ -32, -16 },
						{ -20, -22 },
						{ -20,  -7 },
						{ -20,   8 },
						{ -20,  23 },
						{  -5, -10 },
						{  -5,  10 },
						{  -12,  0 }
};


void c_my_client::prepare_game( void ) {
	cout << "Hello from player nr. " << init_info.play_nr << " on side " \
	  << init_info.play_side << "\n";

	move( init_positions[ init_info.play_nr-1 ].x,
	  init_positions[ init_info.play_nr-1 ].y );
	wait_for_server();

	// init control-variables
	client_moved = 1;
}


void c_my_client::mode_changed( enum play_mode_t new_mode, char side = 0 ) {
}


void c_my_client::hear_from_direction( float simtime, float direction, 
char *msg) {

#ifdef CHECK_HEAR_DIRECTION
	COUT_TIME;
	cout << "  ->hear from " << direction << " message \"" << msg << "\"\n";
#endif
}


void c_my_client::see_flag_penalty( float simtime, struct obj_info_t obj, 
  char x, char y ) {

#ifdef CHECK_FLAGS_PENALTY
	COUT_TIME;
	COUT_OBJ_INFO;
	cout << "  ->see vertual flags (" << x << "," << y << ")\n";
#endif

}


void c_my_client::see_flag( float simtime, struct obj_info_t obj, char x, 
  char y ) {

#ifdef CHECK_SEE_FLAG
	COUT_TIME;
	COUT_OBJ_INFO;
	cout << "  ->see flag (" << x << "," << y << ")\n";
#endif

}


void c_my_client::see_flag( float simtime, struct obj_info_t obj, FlagPos pos ) {

#ifdef CHECK_SEE_FLAG
	COUT_TIME;
	COUT_OBJ_INFO;
	cout << "  ->see flag with FlagPos given\n";
#endif

}


void c_my_client::see_flag_penalty( float simtime, struct obj_info_t obj, FlagPos flagpos ) {

#ifdef CHECK_SEE_FLAG_PENALTY
	COUT_TIME;
	COUT_OBJ_INFO;
	cout << "  ->see vertual flags with FlagPos given\n";
#endif

}


void c_my_client::see_flag_center( float simtime, struct obj_info_t obj ) {
#ifdef CHECK_SEE_FLAG_CENTER
	COUT_TIME;
	COUT_OBJ_INFO;
	cout << "  ->see center flag\n";
#endif
}


void c_my_client::see_flag_goal( float simtime, struct obj_info_t obj, FlagPos flagpos ) {
#ifdef CHECK_SEE_FLAG_GOAL
	COUT_TIME;
	COUT_OBJ_INFO;
	cout << "  ->see goal flag\n";
#endif
}


void c_my_client::see_flag_outside( float simtime, struct obj_info_t obj, FlagPos flagpos, int flag_outside_dist ) {
#ifdef CHECK_SEE_FLAG_OUTSIDE_X_Y
	COUT_TIME;
	COUT_OBJ_INFO;
	cout << "  ->see a flag outside (x,y)\n";
#endif
}

void c_my_client::see_flag_outside( float simtime, struct obj_info_t obj, FlagPos flagpos ) {
#ifdef CHECK_SEE_FLAG_OUTSIDE
	COUT_TIME;
	COUT_OBJ_INFO;
	cout << "  ->see a flag outside\n";
#endif
}


void c_my_client::see_flag( float simtime, struct obj_info_t obj ) {

#ifdef CHECK_SEE_FLAG_OBJINFO
	COUT_TIME;
	COUT_OBJ_INFO;
	cout << "  ->see flag\n";
#endif
}


void c_my_client::see_goal( float simtime, struct obj_info_t obj, char side ) {

#ifdef CHECK_SEE_GOAL_XY
	COUT_TIME;
	COUT_OBJ_INFO;
	cout << "  ->see goal on side " << side << "\n";
#endif
}


void c_my_client::see_goal(float simtime, struct obj_info_t obj, enum _Side side ) {
#ifdef CHECK_SEE_GOAL_SIDE
	COUT_TIME;
	COUT_OBJ_INFO;
	cout << "  ->see goal on side \n";
#endif
}


void c_my_client::see_goal( float simtime , struct obj_info_t obj ) {

#ifdef CHECK_SEE_GOAL
	COUT_TIME;
	COUT_OBJ_INFO;
	cout << "  ->see goal\n";
#endif
}


void c_my_client::see_line( float simtime, struct obj_info_t obj, char pos ) {

#ifdef CHECK_SEE_LINE
	COUT_TIME;
	COUT_OBJ_INFO;
	cout << "  ->see line on pos " << pos << "\n";
#endif
}


void c_my_client::see_line( float simtime, struct obj_info_t obj ) {

#ifdef CHECK_SEE_LINE
	COUT_TIME;
	COUT_OBJ_INFO;
	cout << "  ->see line \n";
#endif
}


void c_my_client::see_line( float simtime, struct obj_info_t obj, LinePos linepos ) {

#ifdef CHECK_SEE_LINE_XY
	COUT_TIME;
	COUT_OBJ_INFO;
	cout << "  ->see line with LinePos given\n";
#endif
}


void c_my_client::see_ball( float simtime, struct obj_info_t obj ) {

#ifdef CHECK_SEE_BALL
	COUT_TIME;
	COUT_OBJ_INFO;
	cout << "  ->see ball\n";
#endif
}


void c_my_client::see_player( float simtime, struct obj_info_t obj, WhichTeam team,
  int nr ) {
#ifdef CHECK_SEE_PLAYER_NAME
	COUT_TIME;
	COUT_OBJ_INFO;
	cout << "  ->see player of " << ((team == WT_Our) ? "our " : "opponent") << "team!"\
	  "with nr = " << nr << '\n';
#endif
}


void c_my_client::see_player( float simtime, struct obj_info_t obj, WhichTeam team) {
#ifdef CHECK_SEE_PLAYER_NAME
	COUT_TIME;
	COUT_OBJ_INFO;
	cout << "  ->see player of " << (char *) ((team == WT_Our) ? "our " : "opponent") << "team!\n";
#endif
}


void c_my_client::see_player( float simtime, struct obj_info_t obj ) {

#ifdef CHECK_SEE_PLAYER
	COUT_TIME;
	COUT_OBJ_INFO;
	cout << "  ->see player\n";
#endif
}

void c_my_client::see_player_and_face( float simtime, struct obj_info_t obj, WhichTeam team,
  int nr, float face_dir ) {
#ifdef CHECK_SEE_PLAYER_NAME_AND_FACE
	COUT_TIME;
	COUT_OBJ_INFO;
	cout << "  ->see player of " << ((team == WT_Our) ? "our " : "opponent") << "team!"\
	  "with nr = " << nr << " facing to " << face_dir << '\n';
#endif
}


void c_my_client::see_player_and_face( float simtime, struct obj_info_t obj, WhichTeam team, float face_dir ) {
#ifdef CHECK_SEE_PLAYER_NAME_AND_FACE
	COUT_TIME;
	COUT_OBJ_INFO;
	cout << "  ->see player of " << (char *) ((team == WT_Our) ? "our " : "opponent") << "team facing to "
	  << face_dir << "!\n";
#endif
}


void c_my_client::see_player_and_face( float simtime, struct obj_info_t obj, float face_dir ) {

#ifdef CHECK_SEE_PLAYER_AND_FACE
	COUT_TIME;
	COUT_OBJ_INFO;
	cout << "  ->see player facing to " << face_dir << "\n";
#endif
}


void c_my_client::idle( void ) {
	usleep( 500000 );
	say( "BLA" );
}


void c_my_client::bye( void ) {
	cout << "Bye!\n";
}


#if !defined( __CHECK_GRAMMAR )
// possible args:
// <teamname> [ <hostname> ]
int main( int argc, char *argv[] ) {
	c_connection 	server_con;
	c_my_client 	player;
	c_kernel	kernel;

	if( argc < 2 ) {
		cerr << "use:  first <teamname> [ <hostname> ]\n\n";
		return 1;
	}


	if( server_con.open( (argc > 2 ) ? argv[ 2 ] : "", 
	  DEFAULT_SERVER_PORT ) ) {
		cerr << "failed to connect to server!\n\n";
		return 1;
	}

	player.set_connection( &server_con );
	player.init( argv[ 1 ] );
	player.prepare_game();

	kernel.set_object( &player );

	kernel.run();

	player.release_connection();
	server_con.shutdown();
	return 0;
}
#endif
