#ifndef __PLAYER_H
#define __PLAYER_H

#include "default.h"
#include "basics.h"
#include "connection.h"

#include "libsclient.h"

struct init_info_t {
	char			team_name[ 255 ]; // 255 should be enough... or?
	char 			play_side;
	int			play_nr;
	enum play_mode_t	play_mode;
};


class c_player : public c_basics {
	public:
		c_player( void ) : c_basics() {};

		virtual struct init_info_t * init( const char * );
		virtual void move( float, float );
		virtual void turn( int );
		virtual void dash( int );
		virtual void kick( int, int );
		virtual void change_view( const char *, const char * );
		virtual void reconnect( void );
		virtual void reconnect( char *, int );
	protected:
		virtual struct init_info_t * init( const char *, SenderType );

		struct init_info_t 	init_info;
};


class c_goalie : public c_player {
	public:
		c_goalie() : c_player() {};

		virtual struct init_info_t * init( const char * );

		virtual void catch_ball( int dir );
};
#endif

