%{
#include <stdlib.h>
#include <stdio.h>

/* not fine, but works: */
#ifndef __CHECK_GRAMMAR
#define printf(s)
#endif
%}

h_tab			[\011]
form_feed		[\014]
v_tab			[\013]
c_return		[\015]

horizontal_white	[ ]|{h_tab}

character		[0-9a-zA-Z().+*/?<>_]

float_nr		([-+]?)([0-9]+)"."([0-9]+)
int_nr 			[-+]?([0-9]+)

s_char			[^\)]

word_string		{character}+


%%

\(			{ return( L_BRAK ); }

\)			{ return( R_BRAK ); }

{float_nr}		{
				printf( "FLOAT\n" );
				yylval.float_nr = atof( yytext );
				return( SYMB_FLOAT_NR );
			}

{int_nr}		{
				printf( "INT\n" );
				yylval.int_nr = atoi( yytext );
				return( SYMB_INT_NR );
			}

hear			{ printf( "hear\n" ); return( SYMB_AV_HEAR );}
see			{ printf( "see\n" ); return( SYMB_AV_SEE ); }

referee			{ printf( "referee\n" ); return( SYMB_OBJ_REFEREE ); }
self			{ printf( "self\n" ); return( SYMB_OBJ_SELF ); }

player 			{ printf( "player\n" ); return( SYMB_OBJ_player ); }
Player 			{ printf( "Player\n" ); return( SYMB_OBJ_PLAYER ); }
ball			{ printf( "ball\n" ); return( SYMB_OBJ_ball ); }
Ball			{ printf( "Ball\n" ); return( SYMB_OBJ_BALL ); }
goal 			{ printf( "goal\n" ); return( SYMB_OBJ_goal ); }
Goal 			{ printf( "Goal\n" ); return( SYMB_OBJ_GOAL ); }
flag 			{ printf( "flag\n" ); return( SYMB_OBJ_flag ); }
Flag			{ printf( "Flag\n" ); return( SYMB_OBJ_FLAG ); }
line			{ printf( "line\n" ); return( SYMB_OBJ_line ); }
p			{ printf( "Penalty\n" ); return( SYMB_OBJ_PENALTY ); }
g			{ printf( "Goal\n" ); return( SYMB_OBJ_GOALFLAG ); }
r|l|c|t|b			{ 	printf( "HVPOS\n" ); 
				yylval.character = yytext[ 0 ];
				return( SYMB_OBJ_hv_pos );
			}
before_kick_off		{ printf( "before_kick_off\n" ); return( SYMB_MD_BEFORE_KICKOFF ); }
time_over		{ printf( "time_over\n" ); return( SYMB_MD_TIME_OVER ); }
play_on			{ printf( "play_on\n" ); return( SYMB_MD_PLAY_ON ); }
kick_off_l		{ printf( "kick_off_l\n" ); return( SYMB_MD_KICK_OFF_L ); }
kick_off_r		{ printf( "kick_off_r\n" ); return( SYMB_MD_KICK_OFF_R ); }
kick_in_l		{ printf( "kick_in_l\n" ); return( SYMB_MD_KICK_IN_L ); }
kick_in_r		{ printf( "kick_in_r\n" ); return( SYMB_MD_KICK_IN_R ); }
free_kick_l		{ printf( "free_kick_l\n" ); return( SYMB_MD_FREE_KICK_L ); }
free_kick_r		{ printf( "free_kick_r\n" ); return( SYMB_MD_FREE_KICK_R ); }
corner_kick_l		{ printf( "corner_kick_l\n" ); return( SYMB_MD_CORNER_KICK_L ); }
corner_kick_r		{ printf( "corner_kick_r\n" ); return( SYMB_MD_CORNER_KICK_R ); }
goal_kick_l		{ printf( "goal_kick_l\n" ); return( SYMB_MD_GOAL_KICK_L ); }
goal_kick_r		{ printf( "goal_kick_r\n" ); return( SYMB_MD_GOAL_KICK_R ); }
goal_l			{ printf( "goal_l\n" ); return( SYMB_MD_GOAL_L ); }
goal_r			{ printf( "goal_r\n" ); return( SYMB_MD_GOAL_R ); }

%%

#ifndef __CHECK_GRAMMAR
#undef printf
#endif
